//-----------------------------------Halsafar Dynamic Array------------------------------//
//Title:            Halsafars Dynamic Array                                              //
//File:             cls_Array.h                                                          // 
//Functionality:    Comparible to that of std::vector. Benchmarked proved to be faster.  //
//                  The array still requires strict adherance to C rules, as it resembles//
//                  the standard vb array.                                               //
//Date:             March 3, 2005 - 13:13                                                //
//Author:           Steve Damm (Halsafar)                                                //
//                                                                                       //
//Notes:            Use of this array is entitled to those who notify me prior to        //
//                  implimentation into their source.  Credit to Steve Damm must be      //
//                  included once within the users source.                               //
//---------------------------------------------------------------------------------------//

#pragma once
#ifndef __DYNAMICARRAY
#define __DYNAMICARRAY

#include "cls_SLAQ.h"

//HALSAFARS DYNAMIC SELF-MANAGING ARRAY
template <class _TY> class ARRAY;  //Prototype 
template <class _TY> 
class ARRAY : public SLAQ<_TY>
{
private:
    //--------------------
    //Private Functions
    virtual void Destroy() {                    //Array is destroyed but keeps the same allocater
        SAFE_FREE(m_Begin);

        m_End   = 0;
        m_TotalSize = 0;
        return;
    }
    //--------------------
public:
    //--------------------
    //Constructor
    ARRAY(UINT uiUBound) {
        m_SizeOf = SizeOf();
        Allocate(uiUBound);
    }

    //Destructor
    ~ARRAY() {
        Destroy();
    }
    //--------------------

    //--------------------
    //Self Managing functions
    bool Resize(UINT uiSize) {                  //Resize the array to any specified size
        return ReAllocate(uiSize);
    }
    //--------------------

    //--------------------
    //Overloaded operators
    _TY &operator [](UINT i) {
        return m_Begin[i];
    }

    _TY *operator ++() {
        return ++m_Begin;
    }


    _TY *operator +=(int i) {
        return (m_Begin += i);
    }

    _TY *operator --() {
        return --m_Begin;
    }


    _TY *operator -=(int i) {
        return (m_Begin -= i);
    }

    //--------------------
};

#endif