//*********************************
//Halsafar's 3D City - Query Performance Counter - Implimentation
//
//Functions: Runs a QueryPerformance Timers with Ez functionality
//
//Date: August 2004, Modified February 2005
//
//Author: Steve Damm
//
//*********************************
#include "../Header/cls_Timer.h"

//----------------
//Constructor
//----------------
TimerEngine::TimerEngine():
Delta(35), 
Hours(0), Minutes(0), Seconds(0), MilliSeconds(0)
{
	//0 all value's
	Start.QuadPart = 0;
	Finish.QuadPart = 0;
	Frequency.QuadPart = 0;

	Init();	//Init high performance counter
	if (Frequency.QuadPart == 0) Frequency.QuadPart = 1;	//If the system has no counter
	
}


//----------------
//Destructor
//----------------
TimerEngine::~TimerEngine()
{

}


//----------------
//Set the milliseconds
//----------------
void TimerEngine::SetMilliSeconds()
{
	MilliSeconds += Delta;

	while (MilliSeconds >= 1000)
	{
		Seconds += 1;
		MilliSeconds -= 1000;
	}
}

//----------------
//Set the Seconds
//----------------
void TimerEngine::SetSeconds()
{
	while (Seconds >= 60)
	{
		Minutes += 1;
		Seconds -= 60;
	}
}

//----------------
//Set the Minutes
//----------------
void TimerEngine::SetMinutes()
{
	while (Minutes >= 60)
	{
		Hours += 1;
		Minutes -= 60;
	}
}

//----------------
//Set the Hours
//----------------
void TimerEngine::SetHours()
{
	while (Hours >= 24)
	{
		Hours -= 24;
	}
}

//----------------
//Set the timer string
//----------------
void TimerEngine::SetTimerString()
{
	//HH:MM:SS
	char szSeconds[3];
	char szMinutes[3];
	char szHours[3];

	sprintf(szSeconds, "%i", Seconds);
	sprintf(szMinutes, "%i:", Minutes);
	sprintf(szHours, "%i:", Hours);

	strcat(szMinutes, szSeconds);
	strcat(szHours, szMinutes);

	strTime = szHours;
}
